#!/usr/bin/python
# -*- coding: utf-8 -*-

#-------------------------------
# mulmatrix.py
#   2012/02/02 - Jun Mizutani
#-------------------------------
import time

def mulMatrix(mr, ma, mb):
  a0 =ma[ 0];  a1 =ma[ 1];  a2 =ma[ 2];  a3 =ma[ 3]
  a4 =ma[ 4];  a5 =ma[ 5];  a6 =ma[ 6];  a7 =ma[ 7]
  a8 =ma[ 8];  a9 =ma[ 9];  a10=ma[10];  a11=ma[11]
  a12=ma[12];  a13=ma[13];  a14=ma[14];  a15=ma[15]
  b0 =mb[ 0];  b1 =mb[ 1];  b2 =mb[ 2];  b3 =mb[ 3]
  b4 =mb[ 4];  b5 =mb[ 5];  b6 =mb[ 6];  b7 =mb[ 7]
  b8 =mb[ 8];  b9 =mb[ 9];  b10=mb[10];  b11=mb[11]
  b12=mb[12];  b13=mb[13];  b14=mb[14];  b15=mb[15]

  mr[ 0] = a0 * b0 + a4 * b1 +  a8 * b2 + a12 * b3
  mr[ 1] = a1 * b0 + a5 * b1 +  a9 * b2 + a13 * b3
  mr[ 2] = a2 * b0 + a6 * b1 + a10 * b2 + a14 * b3
  mr[ 3] = a3 * b0 + a7 * b1 + a11 * b2 + a15 * b3
  mr[ 4] = a0 * b4 + a4 * b5 +  a8 * b6 + a12 * b7
  mr[ 5] = a1 * b4 + a5 * b5 +  a9 * b6 + a13 * b7
  mr[ 6] = a2 * b4 + a6 * b5 + a10 * b6 + a14 * b7
  mr[ 7] = a3 * b4 + a7 * b5 + a11 * b6 + a15 * b7
  mr[ 8] = a0 * b8 + a4 * b9 +  a8 * b10+ a12 * b11
  mr[ 9] = a1 * b8 + a5 * b9 +  a9 * b10+ a13 * b11
  mr[10] = a2 * b8 + a6 * b9 + a10 * b10+ a14 * b11
  mr[11] = a3 * b8 + a7 * b9 + a11 * b10+ a15 * b11
  mr[12] = a0 * b12+ a4 * b13+  a8 * b14+ a12 * b15
  mr[13] = a1 * b12+ a5 * b13+  a9 * b14+ a13 * b15
  mr[14] = a2 * b12+ a6 * b13+ a10 * b14+ a14 * b15
  mr[15] = a3 * b12+ a7 * b13+ a11 * b14+ a15 * b15

a = [  0.,  1.,  2.,  3., 4.,  5.,  6.,  7.,
       8.,  9., 10., 11., 12., 13., 14., 15.]
b = [  1.,  2.,  3., 4.,  1.,  2.,  3., 4.,
       1.,  2.,  3., 4.,  1.,  2.,  3., 4. ]
c = [  0., 0., 0., 0., 0., 0., 0., 0., 
       0., 0., 0., 0., 0., 0., 0., 0.]

start = time.time()

for i in range(1000000):
    mulMatrix(c, b, a)

print("%f sec\n" % (time.time() - start))
print(c)
